
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
import java.util.StringTokenizer;

/**
 *
 * @author cteam17
 */
public class execute {
    
    StringTokenizer st = new StringTokenizer("");
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception{
        execute instance = new execute();
        while (instance.run()){};
    }
    
    String nextToken() throws Exception{
        while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
        return st.nextToken();
    }
    
    long nextLong() throws Exception{
        return Long.parseLong(nextToken());
    }
    
    List<String> commands;
    Stack<Long> stack;
    
    boolean run() throws Exception{
       commands  = new ArrayList<String>();
       String command;
       do{
           command = nextToken();
           if (command.equals("QUIT")){
               return false;
           }
           if (command.equals("NUM")){
               command += " " + nextToken();
           }
           commands.add(command);
       }while(!command.equals("END"));
       long count = nextLong();
       for (int i = 0; i < count; i++){
           stack = new Stack<Long>();
           stack.push(nextLong());
           Long result = execute(stack, commands);
           System.out.println(result == null ? "ERROR" : String.valueOf(result));
       }
       System.out.println();
       return true;
    }

    private Long execute(Stack<Long> stack, List<String> commands) {
        try{
            for (String c : commands){
                if (c.startsWith("NUM")){
                    Long num = Long.valueOf(c.substring(c.indexOf(" ") + 1));
                    stack.push(num);
                }
                else if (c.equals("POP")){
                    stack.pop();
                }
                else if (c.equals("INV")){
                    Long num = stack.pop();
                    stack.push(-num);
                }
                else if (c.equals("DUP")){
                    Long num = stack.peek();
                    stack.push(num);
                }
                else if (c.equals("SWP")){
                    Long num1 = stack.pop();
                    Long num2 = stack.pop();
                    stack.push(num1);
                    stack.push(num2);
                }
                else if (c.equals("ADD")){
                    Long num1 = stack.pop();
                    Long num2 = stack.pop();
                    if (Math.abs(num1 + num2) > 1000000000){
                        throw new Exception();
                    }
                    stack.push(num1 + num2);
                }
                else if (c.equals("SUB")){
                    Long num1 = stack.pop();
                    Long num2 = stack.pop();
                    if (Math.abs(num2 - num1) > 1000000000){
                        throw new Exception();
                    }
                    stack.push(num2 - num1);
                }
                else if (c.equals("MUL")){
                    Long num1 = stack.pop();
                    Long num2 = stack.pop();
                    if (Math.abs(num1 * num2) > 1000000000){
                        throw new Exception();
                    }
                    stack.push(num1 * num2);
                }
                else if (c.equals("DIV")){
                    Long num1 = stack.pop();
                    Long num2 = stack.pop();
                    stack.push(num2 / num1);
                }
                else if (c.equals("MOD")){
                    Long num1 = stack.pop();
                    Long num2 = stack.pop();
                    stack.push(num2 % num1); 
                }
            }
            if (stack.size() != 1){
                return null;
            }
            return stack.peek();
        }
        catch (Exception e){
            return null;
        }
    }

}
